
#pragma region AUTHOR INFORMATION
/***********************************************************************
Author:   Nikhil Srivatsan Srinivasan
Unity ID: nsrivat
Project:  Semantic Analysis
Date:     02/20/2014
***********************************************************************/
#pragma endregion

#pragma region HEADERS
#ifndef SEMANTICS_H
#define SEMANTICS_H
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <stdint.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <stack>
#include "debug.h"

using namespace std;

#pragma endregion

#pragma region PREPROCESSORS
#define OK 100
#define SYSERR -100
#define NOT_PRESENT -1
#define DIMENSIONS_DO_NOT_MATCH -51
#define DIMENSIONS_MATCH 51
#define SOME_DIMENSIONS_MATCH_BUT_NOT_ALL_USED_FOR_PROC 21

// Types of values that can be held by objects.
#define NO_VALUE 0
#define INTEGER 1
#define STRING 2
#define BOOL 3

// These are all the different types of errors that can
// be generated by the compiler. These are not going to
// be used anywhere at the moment. This is just for my
// understanding.
#define INCOMPATIBLE_TYPES 1001;
#define VARIABLE_NOT_DEFINED 1002;
#define TYPE_NOT_DEFINED 1003;
#define REDECLARING_VARIABLE 1004
#define REDECLARING_TYPE 1005

// These are error codes that I will definitely be using.
// This is because I don't want to print the error messages
// from this data structure. So, I will return an error code
// and let BISON act on it.
#define PROC_BEFORE_FORWARD 1006
#define FORWARD_AND_PROC_DONT_MATCH 1007
#define PROC_REDEFINITION 1008

#pragma endregion

#pragma region DECLARATIONS
class TypeTable;
class TypeObject;
class SymbolObject;
class SymbolTable;
class ProcObject;
class ScopeObject;
class ScopeStack;
class varDeets;
class mvrDeets;
class arrayEntities;
#pragma endregion

#pragma region DEFINITIONS

class TypeObject
{
	public:
		string baseType;
		string aliasName;
		vector<int> dimensions;
	public:
		int printTypeObject();
};

class ProcObject
{
	public:
		vector<TypeObject*> argumentList;
		SymbolTable *PST;
		string procName;
		string returnType;
		string procType;
		int lineWhereIWasCalled;
		int lineWhereIWasDeclared;
	public:
		ProcObject();
		int printProcObject();
};

class TypeTable
{
	public:
		vector<TypeObject*> typeTable;
	public:
		TypeTable();
		int lookUpAlias(string);
		int insertInTypeTable(string, string, vector<int>, TypeObject*);
		int printTypeTable();
	};

class SymbolObject
{
	public:
		string nameOfVariable;
		TypeObject *typeObj;
		int addressOfVariable;
	public:
		SymbolObject(string, string, vector<int>, TypeObject*);
	};

class SymbolTable
{
	public:
		vector<SymbolObject*> symbolTable;
		int numberOfSymbols;
	public:
		int lookUpSymbol(string);
		int insertInSymbolTable(string, string, vector<int>, TypeObject*, int);
		void printSymbolTable();
		void incrementSymbolCount();
		int getNumberOfSymbols();
		// Used in code generation.
		SymbolObject* lookUpSymbolInProc(string);
};

class ScopeObject
{
	public:
		TypeTable *typeTableObj;
		SymbolTable *symbolTableObj;
	public:
		ScopeObject();
};

class ScopeStack
{
	public:
		vector<ScopeObject*> scopeStack;
		vector<ProcObject*> procTable;
	public:
		TypeObject* getTypeObjectWhichMatchedOurType(int, string);
		// Methods used only by the scope stack object.
		int createNewScope();
		int popScope();
		int initializePrimitiveDataTypes();
		SymbolObject* getSymbolObject(string);
		TypeObject* getTypeObject(string);
		int createSymbolIfAllChecksAreFine(string, string, vector<int>, int);
		int checkIfTypeExistsAndThenInsertIntoTypeTable(string, string, vector<int>);
		
		// Methods used for manipulating the proctable.
		ProcObject* getProcObject(string);
		int insertInProcTable(vector<TypeObject*>, string, string, string);
		

		// Helper Methods for my data structures.
		int checkIfAliasExistsInCurrentScope(string);
		int findScopeWhereSymbolResides(string);
		int checkIfSymbolExistsInCurrentScope(string);
		int findScopeWhereAliasResides(string);
		int printStack();
};

// Ugly as hell design. These data structures should exist
// inside Bison only. But moved them all here for IDE support.
class varDeets
{
public:
	vector<string> varNames;
	// Used in lvalue. Could have inserted this in the vector
	// but decided to do this instead. Why? Coz, I am an idiot,
	string varName;
	string typeAlias;
	string typeBase;

	// Will be used in code generation. 
	expressionType expType;

	// Used to send up a TK_INT. This will finally be entered
	// in the dimensions vector or can be used in any of the
	// operators. 
	long value;
	// Used with TK_TRUE and TK_FALSE.
	bool boolValue;
	// Vitally important. If value is defined, it means that it
	// is not really an expression, but rather a int, string or
	// bool value. Used in type checking.
	int valueDefined;
	vector<int> dimensions;
	vector<arrayEntities*> arrayValues;
	int numberOfDimensions;
	int dimensionsMatch;
	int iShouldBeProc;
	vector<int> whoAllAreProc;

	// Used only with procs. If there is an ID, then for checking
	// if arguments match correctly, we will need the type. So having
	// a type object here.
	TypeObject* symbolTypeObj;
	// This will be used to get all the type objects because comparison 
	// can be done only at that level.
	vector<TypeObject*> allTypes;
public:
	varDeets();
	int printVarDeets();
	int getTypeBaseCode();
};

class arrayEntities
{
	long integerValue;
	string stringValue;
	int valueType;
};
class mvrDeets
{
public:
	vector<varDeets*> mvrVector;
};

// Methods that we will call from BISON. Once again ugly
// as hell. But IDE man, IDE.
// Check semantics.cc for the definition.
int compareTypes(TypeObject*, TypeObject*);
int compareTypes(varDeets*, varDeets*);
int compareSymbols(varDeets*, varDeets*);
int compareBaseTypes(varDeets*, varDeets*);
int compareBaseTypes(varDeets*, varDeets*, string);
int checkIfAnyForwardHasBeenUsed();
void printErrors(int, int, char*);
#pragma endregion
#endif